using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System.Diagnostics;

namespace Tutorial_4_5
{
    class Circle2D
    {
        private float m_center_x;
        private float m_center_y;
        private float m_radius;

        public Circle2D()
        {
            m_center_x = 0;
            m_center_y = 0;
            m_radius = 0;
        }

        public void SetCenter(float x, float y)
        {
            m_center_x = x;
            m_center_y = y;
        }

        public void SetRadius(float radius)
        {
            m_radius = radius;
        }

        public void Draw(GraphicsDevice device)
        {
            Debug.Assert(device != null, "device not valid on Circle2D draw call");
            if (m_radius > 0)
            {
                const int kNumTriangles = 100;
                VertexPositionColor[] v = new VertexPositionColor[kNumTriangles * 3];

                float theta = (2.0f * (float)Math.PI) / kNumTriangles;

                v[0].Position = new Vector3(m_center_x, m_center_y, 0f);
                v[0].Color = new Color(new Vector4(0.4f, 0.4f, 0.4f, 1f));
                float px = m_center_x + m_radius;
                float py = m_center_y;

                for (int i = 0; i < kNumTriangles; i++)
                {
                    int offset = i * 3;
                    float x = m_center_x + (m_radius * (float)Math.Cos((i+1) * theta));
                    float y = m_center_y + (m_radius * (float)Math.Sin((i+1) * theta));
                    v[offset].Position = v[0].Position;
                    v[offset].Color = v[0].Color;
                    v[offset + 1].Position = new Vector3(px, py, 0f);
                    v[offset + 1].Color = v[0].Color;
                    v[offset + 2].Position = new Vector3(x, y, 0f);
                    v[offset + 2].Color = v[0].Color;

                    px = x;
                    py = y;
                }

                device.DrawUserPrimitives(PrimitiveType.TriangleList, v, 0, kNumTriangles);
            }
        }
    }
}
