using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System.Diagnostics;

namespace Tutorial_5_1
{
    class GrfxWindowXNA
    {
        private Circle2D m_SmallCircle;
        private Rectangle2D m_LargeSquare;

        public GrfxWindowXNA()
        {
            m_SmallCircle = new Circle2D();
            m_LargeSquare = new Rectangle2D();

            m_LargeSquare.SetCenter(120, 82);
            m_LargeSquare.SetSize(80, 80);

            m_SmallCircle.SetCenter(185, 147);
            m_SmallCircle.SetRadius(20);
        }

        //Replaces the PlaceHolder with an XNA graphics the GrfxWindowXNA 
        public void ReplaceFormControl(Control PlaceHolder)
        {
            GrfxSystemXNA.m_TheAPI.CreateGraphicsContext(PlaceHolder.Handle);

            //Links the PlaceHolder's Paint Event with the GrfxWindowXNA's OnPaint event
            PlaceHolder.Paint += new PaintEventHandler(OnPaint);
        }

        //Clears the graphics device and draws the two rectangles to it
        private void OnPaint(object sender, EventArgs e)
        {
            //taking parameters from the grfxPanel guarentees that you get the correct
            //aspect ratio for graphics rendering
            Panel grfxPanel = (Panel)sender;

            GrfxSystemXNA theAPI = GrfxSystemXNA.m_TheAPI;

            if(theAPI.BeginDraw(grfxPanel.Width, grfxPanel.Height))
            {
                //large square
                m_LargeSquare.Draw(theAPI.GetActiveDevice());

                //small square
                m_SmallCircle.Draw(theAPI.GetActiveDevice());

                theAPI.EndDrawAndShow();
            }
        }
    }
}
