using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using UWBGL_WinForms_Lib1;
using UWBGL_XNA_Lib13;

using XNA_SceneNode;

namespace XNA_SceneNode
{
    public partial class XNA_Test : Form
    {
        private DrawOnlyHandler mView;
        private Timer mTimer;

        public XNA_Test()
        {
            mView = new DrawOnlyHandler();
            mTimer = new Timer();            
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
			mView.Initialize(PlaceHolder_Graphics);

			UWB_BoundingBox worldBounds = Program.getModel().getWorldBounds();
			mView.setWCWindow(ref worldBounds);
           
            UWBGL_XNA_Lib13.UWB_Utility.mEchoTextBox = echoTextBox;

            //set our timer's interval in milliseconds and set the mTimer_Tick function to be
            //called every time it reaches that interval
            mTimer.Interval = 25;
            mTimer.Tick += new EventHandler(mTimer_Tick);
            mTimer.Start();

			float width = 0;
			float height = 0;

			Program.getModel().getWorldBounds(ref width, ref height);
           

            UWBGL_XNA_Lib13.UWB_Utility.echoToStatusArea("Form Load Complete");
        }

        private void Button_Quit_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void mTimer_Tick(object sender, EventArgs e)
        {
            Program.getModel().updateSimulation();

            mView.DrawGraphics();
        }	
    }
}
