using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System.Collections.Generic;
using System.Text;

namespace UWBGL_XNA_Lib2
{
    public class UWB_XNAWindowHandler:UWB_WindowHandler
    {
        GraphicsDevice m_XNA_GraphicsDevice;

        public override bool IsGraphicsDeviceValid()
        {
            return (m_XNA_GraphicsDevice != null);
        }

        public override bool InitializeHandler(IntPtr hAttachedWindow)
        {
            m_XNA_GraphicsDevice = null;

            if (!base.InitializeHandler(hAttachedWindow))
                return false;

            UWB_XNAGraphicsSystem.m_TheAPI.CreateGraphicsContext(hAttachedWindow);
            m_XNA_GraphicsDevice = UWB_XNAGraphicsSystem.m_TheAPI.GetActiveDevice();
            return true;
        }

        public override void BeginScene()
        {
            if (m_XNA_GraphicsDevice.GraphicsDeviceStatus == GraphicsDeviceStatus.Normal)
                UWB_XNAGraphicsSystem.m_TheAPI.BeginScene();
        }

        public override void EndSceneAndShow()
        {
            if (m_XNA_GraphicsDevice.GraphicsDeviceStatus == GraphicsDeviceStatus.Normal)
                UWB_XNAGraphicsSystem.m_TheAPI.EndSceneAndShow();
        }
    }
}
