using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using UWBGL_WinForms_Lib1;

namespace XNA_SimulateGravity
{
    public partial class XNA_SimulateGravity : Form
    {
        DrawAndMouseHandler mView;
        Timer mTimer;

        public XNA_SimulateGravity()
        {
            mView = new DrawAndMouseHandler();
            mTimer = new Timer();
            
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Program.getModel().setWorldSize(PlaceHolder_Graphics.Width, PlaceHolder_Graphics.Height);
            mView.Initialize(PlaceHolder_Graphics);
            UWBGL_XNA_Lib2.UWB_XNAUtility.mEchoTextBox = echoTextBox;

            //set our timer's interval in milliseconds and set the mTimer_Tick function to be
            //called every time it reaches that interval
            mTimer.Interval = 25;
            mTimer.Tick += new EventHandler(mTimer_Tick);
            mTimer.Start();

            UWBGL_XNA_Lib2.UWB_XNAUtility.echoToStatusArea("Form Load Complete");
        }

        private void Button_Quit_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void mTimer_Tick(object sender, EventArgs e)
        {
            Program.getModel().updateSimulation();

            mView.DrawGraphics();
        }
    }
}
