using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.Xna.Framework;
using UWBGL_WinForms_Lib1;

namespace XNA_BallShoot
{
    public partial class XNA_BallShoot : Form
    {
        private DrawAndMouseHandler mView;
        private DrawOnlyHandler mSmall;
        private Timer mTimer;
        private static int ballCount = -1;

        public XNA_BallShoot()
        {
            mView = new DrawAndMouseHandler();
            mSmall = new DrawOnlyHandler();
            mTimer = new Timer();            
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Program.getModel().setWorldSize(PlaceHolder_Graphics.Width, PlaceHolder_Graphics.Height);
            mView.Initialize(PlaceHolder_Graphics);
            mSmall.Initialize(panel1);
            UWBGL_XNA_Lib3.UWB_Utility.mEchoTextBox = echoTextBox;

            //set our timer's interval in milliseconds and set the mTimer_Tick function to be
            //called every time it reaches that interval
            mTimer.Interval = 25;
            mTimer.Tick += new EventHandler(mTimer_Tick);
            mTimer.Start();

            mVelocityXSlider.ChangeRangeValues(-100, 100, 0f);
            mVelocityYSlider.ChangeRangeValues(-100, 100, 0f);

            UWBGL_XNA_Lib3.UWB_Utility.echoToStatusArea("Form Load Complete");
        }

        private void Button_Quit_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void mTimer_Tick(object sender, EventArgs e)
        {
            Program.getModel().updateSimulation();

            int currentBallCount = Program.getModel().numBallsOnScreen();
            if (ballCount != currentBallCount)
            {
                ballCount = currentBallCount;
                ballCountText.Text = "Balls in World = " + ballCount;
            }

            Ball ball = Program.getModel().selectedBall();

            if (ball != null)
            {
                Vector3 velocity = ball.getVelocity();
                mVelocityXSlider.SetSliderValue(velocity.X);
                mVelocityYSlider.SetSliderValue(velocity.Y);
            }
            else
            {
                mVelocityXSlider.SetSliderValue(0f);
                mVelocityYSlider.SetSliderValue(0f);
            }

            mView.DrawGraphics();
            mSmall.DrawGraphics();
        }

        private void mVelocityXSlider_Scroll(object sender, EventArgs e)
        {
            float value = mVelocityXSlider.GetSliderValue();
            Ball ball = Program.getModel().selectedBall();

            if (ball != null)
            {
                Vector3 velocity = ball.getVelocity();
                velocity.X = value;
                ball.setVelocity(velocity);
            }
            mVelocityXSlider.SetSliderValue(value);
        }

        private void mVelocityYSlider_Scroll(object sender, EventArgs e)
        {
            float value = mVelocityYSlider.GetSliderValue();
            Ball ball = Program.getModel().selectedBall();

            if (ball != null)
            {
                Vector3 velocity = ball.getVelocity();
                velocity.Y = value;
                ball.setVelocity(velocity);
            }
            mVelocityYSlider.SetSliderValue(value);
        }


    }
}
