using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace UWBGL_XNA_Lib4
{
    public class UWB_LineGeom
    {
		protected Vector3 mStart;
		protected Vector3 mEnd;
		protected Color mColor;
		protected Color mShadingColor;
		protected eShadeMode mShadeMode;

		public UWB_LineGeom()
		{
			mStart = Vector3.Zero;
			mEnd = Vector3.Zero;
			mShadingColor = Color.Black;
		}

		public void setStartPoint(float x, float y, float z)
		{
			mStart.X = x;
			mStart.Y = y;
			mStart.Z = z;
		}

		public Vector3 getStartPoint()
		{
			return mStart;
		}

		public void setEndPoint(float x, float y, float z)
		{
			mEnd.X = x;
			mEnd.Y = y;
			mEnd.Z = z;
		}

		public Vector3 getEndPoint()
		{
			return mEnd;
		}

		public void setColor(Color color)
		{
			mColor = color;
		}

		public Color getColor()
		{
			return mColor;
		}

		public void setShadingColor(Color shadingColor)
		{
			mShadingColor = shadingColor;
		}

		public Color getShadingColor()
		{
			return mShadingColor;
		}

		public void setShadeMode(eShadeMode shadeMode)
		{
			mShadeMode = shadeMode;
		}

		public eShadeMode getShadeMode()
		{
			return mShadeMode;
		}

		public void draw(UWB_DrawHelper drawHelper)
		{
			if (drawHelper != null)
			{
				drawHelper.resetAttributes();
				drawHelper.setShadeMode(mShadeMode);
				drawHelper.setColor1(mColor);
				drawHelper.setColor2(mShadingColor);
				drawHelper.drawLine(mStart, mEnd);
			}
		}
    }
}
