using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using UWBGL_WinForms_Lib1;

namespace XNA_ObjectsAndAttributes
{
    public partial class XNA_ObjectsAndAttributes : Form
    {
        private DrawAndMouseHandler mView;
        private Timer mTimer;

        public XNA_ObjectsAndAttributes()
        {
            mView = new DrawAndMouseHandler();
            mTimer = new Timer();            
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Program.getModel().setWorldSize(PlaceHolder_Graphics.Width, PlaceHolder_Graphics.Height);
            mView.Initialize(PlaceHolder_Graphics);
           
            UWBGL_XNA_Lib4.UWB_Utility.mEchoTextBox = echoTextBox;

            //set our timer's interval in milliseconds and set the mTimer_Tick function to be
            //called every time it reaches that interval
            mTimer.Interval = 25;
            mTimer.Tick += new EventHandler(mTimer_Tick);
            mTimer.Start();

			sliderPointSize.ChangeRangeValues(0, 15, 2f);

			Program.getModel().setShadeMode(UWBGL_XNA_Lib4.eShadeMode.smFlat);

            UWBGL_XNA_Lib4.UWB_Utility.echoToStatusArea("Form Load Complete");
        }

        private void Button_Quit_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void mTimer_Tick(object sender, EventArgs e)
        {
            Program.getModel().updateSimulation();

            mView.DrawGraphics();
        }

		private void sliderPointSize_Scroll(object sender, EventArgs e)
		{
			float value = sliderPointSize.GetSliderValue();
			Program.getModel().setPointSize(value);
		}

		private void radioPoint_CheckedChanged(object sender, EventArgs e)
		{
			Program.getModel().setCurrentGraphicsType(GraphicsObjectType.gotPoint);
			if (Program.getModel().getShadeMode() == UWBGL_XNA_Lib4.eShadeMode.smGouraud)
				checkBoxShading.Checked = true;
			else
				checkBoxShading.Checked = false;
		}

		private void radioLine_CheckedChanged(object sender, EventArgs e)
		{
			Program.getModel().setCurrentGraphicsType(GraphicsObjectType.gotLine);
			if (Program.getModel().getShadeMode() == UWBGL_XNA_Lib4.eShadeMode.smGouraud)
				checkBoxShading.Checked = true;
			else
				checkBoxShading.Checked = false;
		}

		private void radioCircle_CheckedChanged(object sender, EventArgs e)
		{
			Program.getModel().setCurrentGraphicsType(GraphicsObjectType.gotCircle);
			if (Program.getModel().getShadeMode() == UWBGL_XNA_Lib4.eShadeMode.smGouraud)
				checkBoxShading.Checked = true;
			else
				checkBoxShading.Checked = false;
		}

		private void buttonColor_Click(object sender, EventArgs e)
		{
			if (colorDialog.ShowDialog() != DialogResult.Cancel)
			{
				Microsoft.Xna.Framework.Color color = new Microsoft.Xna.Framework.Color(
					colorDialog.Color.R,
					colorDialog.Color.G,
					colorDialog.Color.B,
					colorDialog.Color.A);

				Program.getModel().setObjectColor(color);
			}
		}

		private void buttonShadingColor_Click(object sender, EventArgs e)
		{
			if (shadingColorDialog.ShowDialog() != DialogResult.Cancel)
			{
				Microsoft.Xna.Framework.Color color = new Microsoft.Xna.Framework.Color(
						shadingColorDialog.Color.R,
						shadingColorDialog.Color.G,
						shadingColorDialog.Color.B,
						shadingColorDialog.Color.A);

				Program.getModel().setObjectShadingColor(color);
			}
		}

		private void checkBoxShading_CheckedChanged(object sender, EventArgs e)
		{
			if(checkBoxShading.Checked)
				Program.getModel().setShadeMode(UWBGL_XNA_Lib4.eShadeMode.smGouraud);
			else
				Program.getModel().setShadeMode(UWBGL_XNA_Lib4.eShadeMode.smFlat);
		}

		private void checkBoxFillCircle_CheckedChanged(object sender, EventArgs e)
		{
			Program.getModel().setCircleFillMode(checkBoxFillCircle.Checked);
		}


    }
}
