using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using Microsoft.Xna.Framework;
using UWBGL_WinForms_Lib1;
using UWBGL_XNA_Lib8;

namespace XNA_TranslateSingleObject
{
    class DrawOnlyHandler : UWB_XNAWindowHandler
    {
        private UWBGL_UIWindow mWindow;

        public DrawOnlyHandler()
        {
            mWindow = new UWBGL_UIWindow(true);
        }

        public bool Initialize(Control PlaceHolder)
        {
            if (!mWindow.ReplaceFormControl(PlaceHolder.Handle))
                return false;

            if (!mWindow.AttachHandler(this))
                return false;
            
            return true;
        }

        public override void DrawGraphics()
        {
			float width = 0;
			float height = 0;
			Program.getModel().getWorldBounds(ref width, ref height);
			width = height * getAspectRatio();

			Vector3 scale = new Vector3(2f / width, 2f / height, 0);
			Vector3 translate = new Vector3(-1f, -1f, 0);
			Matrix world2ndc = Matrix.Identity * Matrix.CreateScale(scale) * Matrix.CreateTranslation(translate);

			UWB_XNAGraphicsSystem.m_TheAPI.setViewMatrix(world2ndc);

            BeginScene();

            Program.getModel().drawModel();

            EndSceneAndShow();
        }
    }
}
