using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using UWBGL_WinForms_Lib1;
using UWBGL_XNA_Lib8;

namespace XNA_TranslateSingleObject
{
    public partial class XNA_TranslateSingleObject : Form
    {
        private DrawOnlyHandler mView;
		private UWB_BoundingBox worldBound;
        private Timer mTimer;

        public XNA_TranslateSingleObject()
        {
            mView = new DrawOnlyHandler();
            mTimer = new Timer();            
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
			Program.getModel().setWorldAspectRatio(PlaceHolder_Graphics.Width, PlaceHolder_Graphics.Height);
            mView.Initialize(PlaceHolder_Graphics);

			worldBound = Program.getModel().getWorldBounds();
			mView.setWCWindow(ref worldBound);
           
            UWBGL_XNA_Lib8.UWB_Utility.mEchoTextBox = echoTextBox;

            //set our timer's interval in milliseconds and set the mTimer_Tick function to be
            //called every time it reaches that interval
            mTimer.Interval = 25;
            mTimer.Tick += new EventHandler(mTimer_Tick);
            mTimer.Start();

			float width = 0;
			float height = 0;

			Program.getModel().getWorldBounds(ref width, ref height);

			sliderControlY.OrientationToVertical(PlaceHolder_Graphics.Height - 20);
			sliderControlY.ChangeRangeValues(0, height - 1f, 4f);
			sliderControlX.ChangeRangeValues(0, width - 1f, 1f);
			Program.getModel().setTranslation(1, 4);

            UWBGL_XNA_Lib8.UWB_Utility.echoToStatusArea("Form Load Complete");
        }

        private void Button_Quit_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void mTimer_Tick(object sender, EventArgs e)
        {
            Program.getModel().updateSimulation();

            mView.DrawGraphics();
        }

		private void sliderControlY_Scroll(object sender, EventArgs e)
		{
			Program.getModel().setTranslation(sliderControlX.GetSliderValue(), sliderControlY.GetSliderValue());
		}

		private void sliderControlX_Scroll(object sender, EventArgs e)
		{
			Program.getModel().setTranslation(sliderControlX.GetSliderValue(), sliderControlY.GetSliderValue());
		}
    }
}
